package id.durianpay.dpay_flutter;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.os.Build;
import android.util.Log;

import androidx.annotation.RequiresApi;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.Map;

import io.flutter.plugin.common.MethodChannel.Result;

import id.durianpay.android.Durianpay;
import id.durianpay.android.Interfaces.CheckoutResultListener;
import id.durianpay.android.model.DCheckoutOptions;

@RequiresApi(api = Build.VERSION_CODES.LOLLIPOP)
public class DurianpayCheckout implements CheckoutResultListener {
    private Activity activity;
    private Result result;

    public DurianpayCheckout(Activity act) {
        activity = act;
    }

    public void openCheckout(final Map<String, Object> checkoutoptions, final Result result) {
        this.result = result;
        activity.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Log.d("into the class", "DurianpayCheckout");
                final JSONObject options = new JSONObject(checkoutoptions);

                final DCheckoutOptions checkoutOptions = new DCheckoutOptions();
                CheckoutMapper.map(options, checkoutOptions);
                Durianpay.getInstance(activity).checkout(checkoutOptions, DurianpayCheckout.this);
            }
        });
    }

    @SuppressLint("LongLogTag")
    @Override
    public void onSuccess(final String s) {
        activity.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Log.d("from android-sdk to flutter android", s);
                result.success(s);
            }
        });
    }

    @SuppressLint("LongLogTag")
    @Override
    public void onFailure(final String s) {
        activity.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Log.d("from android-sdk to flutter android", s);
                result.success(s);
            }
        });
    }

    @SuppressLint("LongLogTag")
    @Override
    public void onClose(final String s) {
        activity.runOnUiThread(new Runnable() {
            @Override
            public void run() {
                Log.d("from android-sdk to flutter android", s);
                result.success(s);
            }
        });
    }
}
