//
//  Constants.swift
//  dpay_flutter
//
//  Created by user170390 on 5/24/21.
//

import Foundation
import Flutter

struct Constants {
    static let BASE_URL: String = "https://checkout.durianpay.id"
    static let STAGING_BASE_URL: String = "https://checkout-staging.durianpay.id"
    static let LOCAL_BASE_URL: String = "http://localhost:4000"
    
    static let CHECKOUT_URL: String = BASE_URL + "/public?"
    static let STAGING_CHECKOUT_URL: String = STAGING_BASE_URL + "/public?"
    static let LOCAL_CHECKOUT_URL: String = LOCAL_BASE_URL + "/public?"
    
    static let OVO_CUSTOM_URL = "ovo://"
    static let BCA_CUSTOM_URL = "com.bca.bcamobile://"
    static let BNI_CUSTOM_URL = "BNIMobileMBRC://"
    static let APPWATCHLIST: [String] = [BCA_CUSTOM_URL, BNI_CUSTOM_URL, OVO_CUSTOM_URL]
    static let BANKVAPACKAGES = [
        BCA_CUSTOM_URL: "com.bca",
        BNI_CUSTOM_URL: "src.com.bni"
    ]
    
    static let CUSTOMER_ID_TAG = "customerID"
    static let ORDER_ID_TAG = "orderID"
    static let MERCHANT_ID_TAG = "merchantID"
    static let PAYMENT_AMOUNT_TAG = "finalPaymentAmount"
    static let CURRENCY_TAG = "currency"
    static let EVENT_NAME_TAG = "eventName"
    static let EVENT_COUNT_TAG = "num"
    static let SESSION_ID_TAG = "sessionID"
    
    static let CLICKS_SCHEMA = "iglu:id.durianpay/clicks/jsonschema/1-0-0"
    static let COUNT_SCHEMA = "iglu:id.durianpay/counts/jsonschema/1-0-0"
    
    static let SNOWPLOW_APP_ID = "dpay-ios-flutter"
    
    static let SNOWPLOW_URL_STAGING_ENDPOINT = "staging-stats.durianpay.id"
    static let SNOWPLOW_URL_PRODUCTION_ENDPOINT = "stats.durianpay.id"
    
    static let DANA_URL_IDENTIFIER = "https://m.dana.id"
    static let LINKAJA_URL_IDENTIFIER = "https://payment.linkaja.id"
    static let SHOPEEPAY_URL_IDENTIFIER = "itms-appss://apps.apple.com"
    static let BRI_URL_IDENTIFIER = "https://ib.bri.co.id"
    static let MANDIRI_URL_IDENTIFIER = "https://business.bankmandiri.co.id"
    static let PERMATA_URL_IDENTIFIER = "https://www.permatanet.com"
    static let BNI_URL_IDENTIFIER = "https://ibank.bni.co.id"
    static let BCA_URL_IDENTIFIER = "https://www.klikbca.com"
    static let STATIC_LOADING_URL_IDENTIFIER = "https://checkout.durianpay.id/static/loading.html"
    
    static let DANA_COLOR = UIColor.white
    static let LINKAJA_COLOR = UIColor(red: 245/255, green: 245/255, blue: 248/255, alpha: 1)
    static let SHOPEEPAY_COLOR = UIColor(red: 245/255,green: 246/255,blue: 248/255,alpha: 1)
    static let BNI_COLOR = UIColor.white
    static let MANDIRI_COLOR = UIColor.white
    static let BRI_COLOR = UIColor(red: 1/255,green: 54/255,blue: 110/255,alpha: 1)
    static let PERMATA_COLOR = UIColor(red: 21/255,green: 40/255,blue: 67/255,alpha: 1)
    static let BCA_COLOR = UIColor.white
    static let STATIC_COLOR = UIColor.white
}

protocol IDelegate {
    func openDpayDelegate(_ call: FlutterMethodCall, result: @escaping FlutterResult)
}
