//
//  Helper.swift
//  dpay_flutter
//
//  Created by user170390 on 6/15/21.
//

import Foundation

func checkIfInstalled(customURL: String) -> Bool {
    if (UIApplication.shared.canOpenURL(URL(string: customURL)!)) {
        return true
    }
    return false
}

func addQueryParameterToCheckoutUrl(
    checkoutUrl: String,
    query: String,
    options: NSMutableDictionary,
    errorTag: String,
    key: String) throws -> String {
    
    if let object = options.object(forKey: key) as? NSObject,
       String(describing: object) != "" ,
       !object.isEqual(NSNull()) {
        
        var parameterString = query
        parameterString += String(describing: object)
        return parameterString
    } else {throw NSError(domain: errorTag + " must not be empty", code: 400)}
}

func addOptionalQueryParameterToCheckoutUrl(
    checkoutUrl: String,
    query: String,
    options: NSMutableDictionary,
    key: String) throws -> String {
    
    if let object = options.object(forKey: key) as? NSObject,
       String(describing: object) != "" ,
       !object.isEqual(NSNull()) {
        
        var parameterString = query
        parameterString += String(describing: object)
        return parameterString
    }
    return ""
}

extension UIApplication {
    
    class func topViewController(_ viewController: UIViewController? = UIApplication.shared.keyWindow?.rootViewController) -> UIViewController? {
        if let nav = viewController as? UINavigationController {
            return topViewController(nav.visibleViewController)
        }
        if let tab = viewController as? UITabBarController {
            if let selected = tab.selectedViewController {
                return topViewController(selected)
            }
        }
        if let presented = viewController?.presentedViewController {
            return topViewController(presented)
        }
        return viewController
    }
    
    class func topNavigationController(_ viewController: UIViewController? = UIApplication.shared.keyWindow?.rootViewController) -> UINavigationController? {
        
        if let nav = viewController as? UINavigationController {
            return nav
        }
        if let tab = viewController as? UITabBarController {
            if let selected = tab.selectedViewController {
                return selected.navigationController
            }
        }
        return viewController?.navigationController
    }
}
