import Flutter
import UIKit
import WebKit

public class SwiftDpayFlutterPlugin: NSObject, FlutterPlugin {
    

    private var aObjNavi: UINavigationController?
    var delegate : IDelegate
    
    init(pluginRegistrar: FlutterPluginRegistrar, uiViewController: UIViewController) {
            delegate = FlutterDpayPluginDelegate(registrar: pluginRegistrar, viewController: uiViewController)
    }
    
    public static func register(with registrar: FlutterPluginRegistrar) {
        print("registered the method channels")
        let channel = FlutterMethodChannel(name: "dpay_flutter", binaryMessenger: registrar.messenger())
        let viewController: UIViewController =
                    (UIApplication.shared.delegate?.window??.rootViewController)!;
        let instance = SwiftDpayFlutterPlugin(pluginRegistrar: registrar, uiViewController: viewController)
        registrar.addMethodCallDelegate(instance, channel: channel)
    }

  public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
    switch call.method {
        case "openCheckout":
            // let options = call.arguments as! Dictionary<String, Any>
            print("method call function")
            self.delegate.openDpayDelegate(call, result: result)
        default:
            print("no method")
        }
  }
}

public class FlutterDpayPluginDelegate : NSObject, WKNavigationDelegate, IDelegate {
    
    private let flutterRegistrar: FlutterPluginRegistrar
    private var viewController: UIViewController
    
    init(registrar: FlutterPluginRegistrar, viewController: UIViewController) {
        self.flutterRegistrar = registrar
        self.viewController = viewController
    }
   
    
    func openDpayDelegate(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        let dpayDelegate = DpayDelegate()
        dpayDelegate.options = call.arguments as? NSMutableDictionary
        dpayDelegate.pendingResult = result

        dpayDelegate.modalPresentationStyle = .fullScreen
        UIApplication.topViewController()?.present(dpayDelegate, animated: true, completion: nil)
    }
}
